// -------------------------------------------------------------------------------
// 
// 		cwCu		ahvOwb_t@C
// 
// 				Ver 3.16b
// 
// -------------------------------------------------------------------------------

#ifndef __DXBASEIMAGE_H__
#define __DXBASEIMAGE_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxThread.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// L[u}bv̖ʂ̐
#define CUBEMAP_SURFACE_NUM					(6)

#define BASEIM								BaseImageManage

// \̒` --------------------------------------------------------------------

// ėp摜ǂݍ݂ɕKvȃO[of[^W߂\
struct CREATEBASEIMAGETYPE2_GPARAM
{
	int						( *UserImageLoadFunc4[ MAX_USERIMAGEREAD_FUNCNUM ] )( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;	// [U[摜ǂݍ݊֐Ver4
	int						UserImageLoadFuncNum4 ;																		// [U[摜ǂݍ݊֐Ver4̐
	int						GetFormatOnly ;																				// tH[}bg̎擾݂̂sǂ( TRUE:tH[}bg̎擾̂ݍs  FALSE:f[^ǂݍ )
} ;

// 摜̓ǂݍ݂ɕKvȃO[of[^Z߂\
struct LOADBASEIMAGE_GPARAM
{
	CREATEBASEIMAGETYPE2_GPARAM CreateGraphImageType2GParam ;		// CreateGraphImageType2_UseGParam Ŏgpf[^

	STREAMDATASHREDTYPE2W	StreamDataShred2 ;						// Xg[f[^ANZXp֐Q
	STREAMDATASHRED			FileStreamDataShred ;					// t@Cf[^ANZXp֐
	STREAMDATASHRED			MemStreamDataShred ;					// f[^ANZXp֐

	int						ConvertPremultipliedAlpha ;				// ǂݍݏɏZς݃At@̉摜ɕϊ邩ǂ̃tO( TRUE:ϊs  FALSE:ϊsȂ )
	int						AlphaTestImageCreateFlag ;				// At@eXggpOtBbN쐬邩ǂ̃tO( TRUE:eXggp  FALSE:eXg͎gpȂ )
	DWORD					TransColor ;							// ߐF( AlphaTestImageCreateFlag  TRUE ̏ꍇp )
} ;

// BASEIMAGE + DIB ֌W̏\
struct BASEIMAGEMANAGE
{
	int						( *UserImageLoadFunc4[ MAX_USERIMAGEREAD_FUNCNUM ] )( STREAMDATA *Src, BASEIMAGE *BaseImage ) ;																									// [U[摜ǂݍ݊֐Ver4
	int						UserImageLoadFuncNum4 ;																																										// [U[摜ǂݍ݊֐Ver4̐
/*
	int						( *UserImageLoadFunc3[ MAX_USERIMAGEREAD_FUNCNUM ] )( void *DataImage, int DataImageSize, int DataImageType, int BmpFlag, BASEIMAGE *BaseImage, BITMAPINFO **BmpInfo, void **GraphData ) ;		// [U[摜ǂݍ݊֐Ver3
	int						UserImageLoadFuncNum3 ;																																										// [U[摜ǂݍ݊֐Ver3̐

	int						( *UserImageLoadFunc2[ MAX_USERIMAGEREAD_FUNCNUM ] )( void *Image, int ImageSize, int ImageType, BITMAPINFO **BmpInfo, void **GraphData ) ;													// [U[摜ǂݍ݊֐Ver2
	int						UserImageLoadFuncNum2 ;																																										// [U[摜ǂݍ݊֐Ver2̐

	int						( *UserImageLoadFunc[ MAX_USERIMAGEREAD_FUNCNUM ] )( FILE *fp, BITMAPINFO **BmpInfo, void **GraphData ) ;																					// [U[摜ǂݍ݊֐
	int						UserImageLoadFuncNum ;																																										// [U[摜ǂݍ݊֐̐
*/

	DX_CRITICAL_SECTION		CriticalProcessHandle ;					// f[^ՓˉpNeBJZNV
	int						InitializeFlag ;						// tO

	int						Bmp32AllZeroAlphaToXRGB8 ;				// 32bit bmp 摜̂`ׂĂO`𖳎邩ǂ
	int						LowLoadFlag ;							// OtBbN̒ᑬǂݍ݂stO
	int						ImageShavedMode ;						// F̊gUp^[
	int						ConvertPremultipliedAlpha ;				// ǂݍݏɏZς݃At@̉摜ɕϊ邩ǂ̃tO( TRUE:ϊs  FALSE:ϊsȂ )

	int						AlphaTestImageCreateFlag ;				// At@eXggpOtBbN쐬邩ǂ̃tO( TRUE:eXggp  FALSE:eXg͎gpȂ )
	DWORD					TransColor ;							// ߐF( AlphaTestImageCreateFlag  TRUE ̏ꍇp )
} ;


// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ˑ̉摜ǂݍ݊֐z
extern int ( *DefaultImageLoadFunc_PF[] )( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) ;

// {C[WǗpf[^
extern BASEIMAGEMANAGE BaseImageManage ;

// ֐vg^Cv錾-----------------------------------------------------------

// An
extern	int		InitializeBaseImageManage( void ) ;															// {C[WǗ̏
extern	int		TerminateBaseImageManage( void ) ;															// {C[WǗ̌n

// 摜ǂݍ݊֐
extern	int		SetBmp32AllZeroAlphaToXRGB8( int Flag ) ;															// 32bit bmp 摜̂`ׂĂO`𖳎邩ǂ̃tOZbg

extern	int		ScalingBltBaseImage(
					int SrcX1,  int SrcY1,  int SrcX2,  int SrcY2,  BASEIMAGE *SrcBaseImage,
					int DestX1, int DestY1, int DestX2, int DestY2, BASEIMAGE *DestBaseImage, int Bilinear = TRUE ) ;		// {C[Wf[^g]
extern	int		GraphHalfScaleBlt(	const COLORDATA *ColorData,
										      void *DestGraphData, int DestPitch,
										const void *SrcGraphData,  int SrcPitch,
										int DestX, int DestY, int SrcX, int SrcY, int SrcWidth, int SrcHeight ) ;	// Q̂PXP[OȂOtBbNf[^ԓ]sÂߊ{̓]`͎włȂ
extern	int		NoneMaskFill( RECT *Rect, void *ImageData, int Pitch, COLORDATA *ColorData, unsigned int Fill = 0xff ) ;		// gĂȂrbgw̒lŖ߂


extern	int		ConvertYV12ToXRGB32( void *YV12Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// YV12 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertNV11ToXRGB32( void *NV11Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// NV11 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertNV12ToXRGB32( void *NV12Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// NV12 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertYUY2ToXRGB32( void *YUY2Image, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// YUY2 tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertUYVYToXRGB32( void *UYVYImage, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// UYVY tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ
extern	int		ConvertYVYUToXRGB32( void *YVYUImage, int Width, int Height, BASEIMAGE *DestBaseImage ) ;				// YVYU tH[}bg̃C[W XRGB32 ̃rbg}bvC[Wɕϊ

extern	int		ConvertYV12ToYPlane_UVPlane( void *YV12Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// YV12 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertNV11ToYPlane_UVPlane( void *NV11Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// NV11 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertNV12ToYPlane_UVPlane( void *NV12Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// NV12 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertYUY2ToYPlane_UVPlane( void *YUY2Image, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// YUY2 tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertUYVYToYPlane_UVPlane( void *UYVYImage, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// UYVY tH[}bg̃C[W YUṼC[Wɕ
extern	int		ConvertYVYUToYPlane_UVPlane( void *YVYUImage, int Width, int Height, void *YBuffer, void *UVBuffer ) ;	// YVYU tH[}bg̃C[W YUṼC[Wɕ

extern	void	InitCreateBaseImageType2GParam( CREATEBASEIMAGETYPE2_GPARAM *GParam, int GetFormatOnly ) ;				// CREATEBASEIMAGETYPE2_GPARAM ̃f[^Zbg
extern	void	InitLoadBaseImageGParam( LOADBASEIMAGE_GPARAM *GParam, int GetFormatOnly ) ;							// LOADBASEIMAGE_GPARAM ̃f[^Zbg

// CreateGraphImageType2 ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphImageType2_UseGParam( CREATEBASEIMAGETYPE2_GPARAM *GParam, STREAMDATA *Src, BASEIMAGE *Dest ) ;

// CreateGraphImageOrDIBGraph ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphImageOrDIBGraph_UseGParam(
					LOADBASEIMAGE_GPARAM *GParam,
					const wchar_t *FileName,
					const void *DataImage, int DataImageSize, int DataImageType,
					int BmpFlag, int ReverseFlag,
					BASEIMAGE *BaseImage, BITMAPINFO **BmpInfo, void **GraphData
				) ;

// CreateGraphImage_plus_Alpha ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphImage_plus_Alpha_UseGParam(
					LOADBASEIMAGE_GPARAM *GParam,
					const wchar_t *FileName,
					const void *RgbImage, int RgbImageSize, int RgbImageType,
					const void *AlphaImage, int AlphaImageSize, int AlphaImageType,
					BASEIMAGE *RgbGraphImage, BASEIMAGE *AlphaGraphImage, int ReverseFlag
				) ;


// wchar_tŊ֐
extern	int		CreateGraphImageOrDIBGraph_WCHAR_T(    const wchar_t *FileName, const void *DataImage, int DataImageSize, int DataImageType /* LOADIMAGE_TYPE_FILE  */ , int BmpFlag, int ReverseFlag, BASEIMAGE *BaseImage, BITMAPINFO **BmpInfo, void **GraphData ) ;
extern	int		GetImageSize_File_WCHAR_T(             const wchar_t *FileName, int *SizeX, int *SizeY ) ;
extern	int		CreateGraphImage_plus_Alpha_WCHAR_T(   const wchar_t *FileName, const void *RgbBaseImage, int RgbImageSize, int RgbImageType, const void *AlphaImage, int AlphaImageSize, int AlphaImageType, BASEIMAGE *RgbGraphImage, BASEIMAGE *AlphaGraphImage, int ReverseFlag ) ;
#ifdef __WINDOWS__
extern	HBITMAP	CreateDIBGraph_WCHAR_T(                const wchar_t *FileName,                                                                                                                                        int ReverseFlag,          COLORDATA *SrcColor ) ;
extern	int		CreateDIBGraph_plus_Alpha_WCHAR_T(     const wchar_t *FileName, HBITMAP *RGBBmp, HBITMAP *AlphaBmp,                                                                                                    int ReverseFlag = FALSE , COLORDATA *SrcColor = NULL ) ;
extern	HBITMAP	CreateDIBGraphVer2_WCHAR_T(            const wchar_t *FileName, const void *MemImage, int MemImageSize,                                             int ImageType,                                     int ReverseFlag,          COLORDATA *SrcColor ) ;
extern	int		CreateDIBGraphVer2_plus_Alpha_WCHAR_T( const wchar_t *FileName, const void *MemImage, int MemImageSize, const void *AlphaImage, int AlphaImageSize, int ImageType, HBITMAP *RGBBmp, HBITMAP *AlphaBmp, int ReverseFlag,          COLORDATA *SrcColor ) ;
#endif // __WINDOWS__
extern	int		CreateBaseImage_WCHAR_T(               const wchar_t *FileName, const void *FileImage, int FileImageSize, int DataType /*=LOADIMAGE_TYPE_FILE*/ , BASEIMAGE *BaseImage,  int ReverseFlag ) ;
extern	int		CreateBaseImageToFile_WCHAR_T(         const wchar_t *FileName,                                                                                   BASEIMAGE *BaseImage,  int ReverseFlag = FALSE ) ;


#ifndef DX_NON_SAVEFUNCTION

extern	int		SaveBaseImageToBmp_WCHAR_T(            const wchar_t *FilePath, const BASEIMAGE *BaseImage ) ;
extern	int		SaveBaseImageToDds_WCHAR_T(            const wchar_t *FilePath, const BASEIMAGE *BaseImage ) ;
#ifndef DX_NON_PNGREAD
extern	int		SaveBaseImageToPng_WCHAR_T(            const wchar_t *FilePath,       BASEIMAGE *BaseImage, int CompressionLevel ) ;
#endif // DX_NON_PNGREAD
#ifndef DX_NON_JPEGREAD
extern	int		SaveBaseImageToJpeg_WCHAR_T(           const wchar_t *FilePath,       BASEIMAGE *BaseImage, int Quality, int Sample2x1 ) ;
#endif // DX_NON_JPEGREAD

#endif // DX_NON_SAVEFUNCTION



// ˑEI֐
extern	int		InitializeBaseImageManage_PF( void ) ;													// {C[WǗ̊ˑ̏
extern	int		TerminateBaseImageManage_PF( void ) ;													// {C[WǗ̊ˑ̌n



#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXBASEIMAGE_H__
