// -------------------------------------------------------------------------------
// 
// 		cwCu		q[v֌WvOwb_t@C
// 
// 				Ver 3.16b
// 
// -------------------------------------------------------------------------------

#ifndef __DXHEAP_H__
#define __DXHEAP_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxThread.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------


#define HEAPMEM_FLAG_AUTOALLOC					(0x0001)			// mۂ̈悩ǂ

#define ALLOCMEMTAG_MAGIC_ID					(0x4D454D44)		// "DMEM"( rbOGfBAƋtɂȂႤǁEEE )

#define ALLOCMEM_MIN_ALIGNED					(16)				// AC̍Œl
#define ALLOCMEM_CATEGORY_2_SHIFT_NUM			(5)					// JeS[Q̐( 32 )2̏搔

#ifdef __64BIT__
#define ALLOCMEMTAG_NAMELENGTH					(18)				// mۃ̖O
#define ALLOCMEM_CATEGORY_1_NUM					(64)				// JeS[P̐(  0 ` ALLOCMEM_CATEGORY_2_SHIFT_NUM ̃JeS͎gpȂ( łȂ ) )
#define ALLOCMEM_SIZE_TYPE						ULONGLONG			// mۃ̃TCY̌^
#define ALLOCMEMTAG_SIZE						(112)				// ALLOCMEMTAG\̂̃TCY
#else // __64BIT__
#define ALLOCMEMTAG_NAMELENGTH					(18)				// mۃ̖O
#define ALLOCMEM_CATEGORY_1_NUM					(32)				// JeS[P̐(  0 ` ALLOCMEM_CATEGORY_2_SHIFT_NUM ̃JeS͎gpȂ( łȂ ) )
#define ALLOCMEM_SIZE_TYPE						DWORD				// mۃ̃TCY̌^
#define ALLOCMEMTAG_SIZE						(72)				// ALLOCMEMTAG\̂̃TCY
#endif // __64BIT__

#define ALLOCMEMTAG_DEBUGAREA_SIZE				(16)				// fobOp̒lŖ߂̈̃TCY

// ̃mۂŕKvȃ^O֌W̃f[^TCY
#define ALLOCMEMTAG_TOTAL_SIZE					( ALLOCMEMTAG_SIZE + ALLOCMEMTAG_DEBUGAREA_SIZE * 2 + sizeof( DWORD ) )

	// ^O邽߂ɍŒKvȋ󂫃TCY( ACl )
#define ALLOCMEMTAG_MIN_SIZE					( ( ALLOCMEMTAG_TOTAL_SIZE + ALLOCMEM_MIN_ALIGNED * 2 + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED )

#define ALLOCMEMTAG_FLAG_LINE_BIT_16			(0x01)				// sԍ16bit( WORD ł 65535s܂ł\łȂ̂ŁA262143s܂ŕ\ł悤ɂ邽߂̑Ή )
#define ALLOCMEMTAG_FLAG_LINE_BIT_17			(0x02)				// sԍ17bit(  )
#define ALLOCMEMTAG_FLAG_USE					(0x04)				// mہEgpĂ郁ǂ
#define ALLOCMEMTAG_FLAG_NEXT_CONNECT			(0x08)				// Next ̃̈ƃAhXAĂ邩ǂ
#define ALLOCMEMTAG_FLAG_PREV_CONNECT			(0x10)				// Prev ̃̈ƃAhXAĂ邩ǂ

// mۏ^Cv
#define ALLOCMEMTYPE_SIMPLE						(0)					// VvŒᑬȃASY
#define ALLOCMEMTYPE_TLSF						(1)					// TLSF

// q[vmۃR[obN֐Ŏgpł̃TCY
#define ALLOCHEAP_CALLBACK_INFO_SIZE					(32)

// \̒` --------------------------------------------------------------------

// mۃ̃^O
struct ALLOCMEMTAG /* TCY ALLOCMEMTAG_SIZE byte ɂȂ悤ɒ */
{
	DWORD					MagicID ;							// DMEM
	char					Name[ ALLOCMEMTAG_NAMELENGTH ] ;	// t@CpX
	BYTE					Flag ;								// tO( ALLOCMEMTAG_FLAG_USE Ȃ )
	BYTE					Padding ;							// \
	BYTE					FLI ;								// 󂫃Xg̃JeSP( ^Cv ALLOCMEMTYPE_TLSF ̍ۂɎgp )
	BYTE					SLI ;								// 󂫃Xg̃JeSQ( ^Cv ALLOCMEMTYPE_TLSF ̍ۂɎgp )
	WORD					ID ;								// ID
	WORD					Time ;								// 
	WORD					Line ;								// sԍ
	ALLOCMEM_SIZE_TYPE		Size ;								// LĂTCY
	void *					AllocAddress ;						// mۂĂ郁̈̐擪AhX( Owner->UseSeparateInfo = TRUE ̏ꍇ̂ݎgp )
	void *					UserAddress ;						// AllocMemory ̖߂lƂĕԂAhX
	ALLOCMEM_SIZE_TYPE		UserSize ;							// AllocMemory Ŏw肳ꂽTCY
	ALLOCMEMTAG *			Prev ;								// Õ^Oւ̃|C^( [̏ꍇ NULL )
	ALLOCMEMTAG *			Next ;								// ̃^Oւ̃|C^( I[̏ꍇ NULL )
	ALLOCMEMTAG *			ListPrev ;							// Xg̈Õ^Oւ̃|C^( [̏ꍇ NULL )
	ALLOCMEMTAG *			ListNext ;							// Xg̈̃^Oւ̃|C^( I[̏ꍇ NULL )
	struct HEAPINFO *		Owner ;								// ^OĂq[vւ̃|C^
	struct HEAPMEMINFO *	UseHeapMem ;						// gpĂ郁̈ւ̃|C^
} ;

// q[vpɊmۂꂽ̏
struct HEAPMEMINFO
{
	void *					Address ;							// gp\Ƃēnꂽ̈̐擪AhX
	ALLOCMEM_SIZE_TYPE		Size ;								// gp\Ƃēnꂽ̃TCY
	void *					UseAddress ;						// AClꍇɎgpł擪AhX
	ALLOCMEM_SIZE_TYPE		UseSize ;							// AClꍇɎgpł郁̃TCY
	void *					HeapAddress ;						// q[vpɎgpł郁̐擪AhX
	ALLOCMEM_SIZE_TYPE		HeapSize ;							// q[vpɎgpł郁̃TCY
	ALLOCMEM_SIZE_TYPE		UseMemTagCount ;					// ̃gpĂgp^O̐
	ALLOCMEMTAG *			FirstMemTag ;						// ̃gpĂŏ̃^Oւ̃|C^

	HEAPMEMINFO *			Prev ;								// Õq[vpɊmۂꂽ̏ւ̃|C^( [̏ꍇ NULL )
	HEAPMEMINFO *			Next ;								// ̃q[vpɊmۂꂽ̏ւ̃|C^( I[̏ꍇ NULL )

	DWORD					Flag ;								// tO( HEAPMEM_FLAG_AUTOALLOC Ȃ )

	BYTE					CallbackBuffer[ ALLOCHEAP_CALLBACK_INFO_SIZE ] ;	// R[obN֐ŎRɎgpłobt@
} ;

// q[v
struct HEAPINFO
{
	int						AutoAlloc ;							// q[vp̃̈Ŋmۂ邩ǂ( TRUE:Ŋmۂ  FALSE:ł͊mۂȂ )
	ALLOCMEM_SIZE_TYPE		AutoAllocUnitSize ;					// q[vp̃̈Ŋmۂꍇ́AxɊmۂq[v̈̃TCY
	int						AutoAlloc_CallbackParam ;			// InitializeHeap ̈ AutoAlloc_CallbackParam ̒l
	int					 ( *AutoAlloc_CreateHeapCallback     )( int Param, void *Buffer, ALLOCMEM_SIZE_TYPE Size ) ;	// q[vp̃̈Ŋmۂ邽߂̃R[obN֐
	void *				 ( *AutoAlloc_GetHeapAddressCallback )( int Param, void *Buffer ) ;	// q[vp̃̈Ŋmۂꍇ́AAhX擾邽߂̊֐
	ALLOCMEM_SIZE_TYPE	 ( *AutoAlloc_GetHeapSizeCallback    )( int Param, void *Buffer ) ;	// q[vp̃̈Ŋmۂꍇ́ATCY擾邽߂̊֐
	int					 ( *AutoAlloc_DeleteHeapCallback     )( int Param, void *Buffer ) ;	// q[vp̃̈Ŋmۂꍇ́ÄJ邽߂̊֐

	int						AllocType ;							// mۏ^Cv( ALLOCMEMTYPE_SIMPLE  )
	ALLOCMEM_SIZE_TYPE		Aligned ;							// ԂAhX̃AC

	WORD					AllocMemoryID ;						// mۂɊ蓖Ăhc
	WORD					AllocMemoryTime ;					// mۂɐݒ肷鎞

	int						UseSeparateInfo ;					// ^Oq[v̏q[vȊÖ̗Ɋmۂzgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int						SepTagArrayLength ;					// ^Oq[vȊÖ̗Ɋmۂ^Oz̒
	int						SepTagArrayUseNum ;					// ^Oq[vȊÖ̗Ɋmۂ^Oz̓̎gpĂ鐔
	ALLOCMEMTAG *			SepTagArray ;						// ^Oq[vȊÖ̗Ɋmۂ^Ozւ̃|C^
	ALLOCMEMTAG *			SepTagArrayNotUseFirst ;			// ^Oq[vȊÖ̗Ɋmۂ^Oẑ܂gp̃^ÕXg̐擪vfւ̃|C^
	int						SepHeapMemArrayLength ;				// q[vpɊmۂꂽ̏q[vȊÖ̗Ɋmۂz̒
	int						SepHeapMemArrayUseNum ;				// q[vpɊmۂꂽ̏q[vȊÖ̗Ɋmۂz̓̎gpĂ鐔
	HEAPMEMINFO *			SepHeapMemArray ;					// q[vpɊmۂꂽ̏q[vȊÖ̗Ɋmۂzւ̃|C^
	HEAPMEMINFO *			SepHeapMemArrayNotUseFirst ;		// q[vpɊmۂꂽ̏q[vȊÖ̗Ɋmۂẑ܂gp̏̃Xg̐擪vfւ̃|C^

	HEAPMEMINFO *			FirstHeapMem ;						// q[vpɊmۂꂽ̏̃Xg̍ŏ̏ւ̃|C^

	int						FreeTagNum ;						// 󂫃^O̐
	ALLOCMEM_SIZE_TYPE		TotalFreeSize ;						// 󂫃̍vTCY

	ALLOCMEMTAG *			FirstTag ;							// ŏ̃^Oւ̃|C^
	ALLOCMEMTAG *			LastTag ;							// Ō̃^Oւ̃|C^

	int						UseTagNum ;							// gpĂ郁̐
	ALLOCMEM_SIZE_TYPE		TotalUseSize ;						// gpĂ郁̍vTCY
	ALLOCMEMTAG *			UseFirstTag ;						// gp̍ŏ̃^Oւ̃|C^
	ALLOCMEMTAG *			UseLastTag ;						// gp̍Ō̃^Oւ̃|C^


#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
	DX_CRITICAL_SECTION		MemoryAllocCriticalSection ;		// mۏpNeBJZNV
#endif

	// ALLOCMEMTYPE_TLSF ^Cvł̂ݎgp
#ifdef __64BIT__
	ULONGLONG				FreeTagBitList1 ;					// JeSP̋󂫃JeS̃rbgXg
#else // __64BIT__
	DWORD					FreeTagBitList1 ;					// JeSP̋󂫃JeS̃rbgXg
#endif // __64BIT__
	DWORD					FreeTagBitList2[ ALLOCMEM_CATEGORY_1_NUM ] ;												// eJeSP̋󂫃JeSQ̃rbgXg
	ALLOCMEMTAG *			FreeFirstTagArray[ ALLOCMEM_CATEGORY_1_NUM ][ 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ] ;		// eJeS̋󂫃ŏ̃^Oւ̃|C^
	ALLOCMEMTAG *			FreeLastTagArray[  ALLOCMEM_CATEGORY_1_NUM ][ 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ] ;		// eJeS̋󂫃Ō̃^Oւ̃|C^


	// ALLOCMEMTYPE_SIMPLE ^Cvł̂ݎgp
	ALLOCMEMTAG *			FreeFirstTag ;						// 󂫃̍ŏ̃^Oւ̃|C^
	ALLOCMEMTAG *			FreeLastTag ;						// 󂫃̍Ō̃^Oւ̃|C^
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

// q[v
extern	int			InitializeHeap(
						HEAPINFO *				Heap,
						int						AllocType				= ALLOCMEMTYPE_SIMPLE,
						ALLOCMEM_SIZE_TYPE		Aligned					= 16,
						int						AutoAlloc				= TRUE,
						ALLOCMEM_SIZE_TYPE		AutoAllocUnitSize		= 16 * 1024 * 1024,
						int						AutoAlloc_CallbackParam	= 0,
						int					 ( *AutoAlloc_CreateHeapCallback     )( int Param, void *Buffer, ALLOCMEM_SIZE_TYPE Size ) = NULL,
						void *				 ( *AutoAlloc_GetHeapAddressCallback )( int Param, void *Buffer ) = NULL,
						ALLOCMEM_SIZE_TYPE	 ( *AutoAlloc_GetHeapSizeCallback    )( int Param, void *Buffer ) = NULL,
						int					 ( *AutoAlloc_DeleteHeapCallback     )( int Param, void *Buffer ) = NULL,
						void *					HeapAddress				= NULL,
						ALLOCMEM_SIZE_TYPE		HeapSize				= 0,
						int						UseSeparateInfo			= FALSE,
						int						SepTagArrayLength		= 0,
						ALLOCMEMTAG *			SepTagArray				= NULL,
						int						SepHeapMemArrayLength	= 0,
						HEAPMEMINFO *			SepHeapMemArray			= NULL
					) ;
extern	int			TerminateHeap( HEAPINFO *Heap ) ;				// q[v̌ns
extern	int			AddHeapMemory( HEAPINFO *Heap, void *HeapAddress, ALLOCMEM_SIZE_TYPE HeapSize ) ;	// q[vƂĈǉ
extern	int			SubHeapMemory( HEAPINFO *Heap, void *HeapAddress ) ;								// q[vƂĈ炷
extern	ALLOCMEM_SIZE_TYPE	GetHeapTotalMemorySize( HEAPINFO *Heap ) ;	// q[vgpĂ郁̑TCY擾

// q[v烁mۂ( UseSeparateInfo=TRUE ̏ꍇ́A߂Ă̂ ALLOCMEMTAG \̂̃AhX )
extern	void *		AllocMemory(
						HEAPINFO *			Heap,
						ALLOCMEM_SIZE_TYPE	Size,
						ALLOCMEM_SIZE_TYPE	Aligned			= 0,
						int					Reverse			= FALSE,
						const char *		Name			= NULL,
						int					Line			= 0
					) ;
// mۂ̃TCYύX( UseSeparateInfo=TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern	void *		ReallocMemory(
						void *				AllocAddress,
						int					UseSeparateInfo	= FALSE,
						ALLOCMEM_SIZE_TYPE	Size			= 0,
						ALLOCMEM_SIZE_TYPE	Aligned			= 0,
						const char *		Name			= NULL,
						int					Line			= 0
					) ;
extern	int			FreeMemory(            void *AllocAddress, int UseSeparateInfo = FALSE ) ;	// q[vmۂJ( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern	void *		GetAllocMemoryAddress( void *AllocAddress, int UseSeparateInfo = FALSE ) ;	// q[vmۂ̈̃AhX擾( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern	ALLOCMEM_SIZE_TYPE	GetAllocSize(  void *AllocAddress, int UseSeparateInfo = FALSE ) ;	// q[vmۂ̃TCY擾( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern	ALLOCMEMTAG * GetAllocMemTag(      void *AllocAddress, int UseSeparateInfo = FALSE ) ;	// q[vmۂ ALLOCMEMTAG\̂擾( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern	void		PrintInfoMemory(       void *AllocAddress, int UseSeparateInfo = FALSE ) ;	// q[vmۂ̏Oɏo͂( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern	int			HeapInfoDump(      HEAPINFO *Heap ) ;										// q[v̏Oɏo͂
extern	int			SetHeapTime(       HEAPINFO *Heap, WORD Time ) ;							// q[vmۂɐݒ肷鎞ԂύX
extern	int			HeapErrorCheck(    HEAPINFO *Heap ) ;										// q[v̓eɃG[Ȃ`FbN
extern	int			HeapDrawAllocInfo( HEAPINFO *Heap, int x, int y, int Width, int Height ) ;	// q[v̊mۏ󋵂`悷





#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXMEMORY_H__
