// -------------------------------------------------------------------------------
// 
// 		cwCu		ff[^vO( Direct3D11 )wb_t@C
// 
// 				Ver 3.16b
// 
// -------------------------------------------------------------------------------

#ifndef __DXMODELD3D11_H__
#define __DXMODELD3D11_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_GRAPHICS

#ifndef DX_NON_DIRECT3D11

// CN[h ------------------------------------------------------------------

#ifndef DX_NON_MODEL

#include "../DxLib.h"
#include "../DxModel.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ̃bV^Cv_\
struct MV1_VERTEX_SIMPLE_D3D11
{
	VECTOR					Position ;							// W
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	FLOAT4					UVs[ 2 ] ;							// eNX`W
} ;

// ̃bV^Cvov}bvp_\
struct MV1_VERTEX_SIMPLE_BUMP_D3D11
{
	VECTOR					Position ;							// W
	VECTOR					Tangent ;							// _̐ڐ
	VECTOR					Binormal ;							// _̏]@
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	FLOAT4					UVs[ 2 ] ;							// eNX`W
} ;

// XLbV^Cv_\(֘A{[Sȓ)
struct MV1_VERTEX_SKIN_B4_D3D11
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 4 ] ;					// sCfbNX( sԍ~S )
	float					MatrixWeight[ 4 ] ;					// sEGCg
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	FLOAT4					UVs[ 2 ] ;							// eNX`W
} ;

// XLbV^Cvov}bvp_\(֘A{[Sȓ)
struct MV1_VERTEX_SKIN_B4_BUMP_D3D11
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 4 ] ;					// sCfbNX( sԍ~S )
	float					MatrixWeight[ 4 ] ;					// sEGCg
	VECTOR					Tangent ;							// _̐ڐ
	VECTOR					Binormal ;							// _̏]@
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	FLOAT4					UVs[ 2 ] ;							// eNX`W
} ;

// XLbV^Cv_\(֘A{[Wȓ)
struct MV1_VERTEX_SKIN_B8_D3D11
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 8 ] ;					// sCfbNX( sԍ~S )
	float					MatrixWeight[ 8 ] ;					// sEGCg
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	FLOAT4					UVs[ 2 ] ;							// eNX`W
} ;

// XLbV^Cvov}bvp_\(֘A{[Wȓ)
struct MV1_VERTEX_SKIN_B8_BUMP_D3D11
{
	VECTOR					Position ;							// W
	unsigned char			MatrixIndex[ 8 ] ;					// sCfbNX( sԍ~W )
	float					MatrixWeight[ 8 ] ;					// sEGCg
	VECTOR					Tangent ;							// _̐ڐ
	VECTOR					Binormal ;							// _̏]@
	VECTOR					Normal ;							// @
	COLOR_U8				DiffuseColor ;						// fBt[YF
	COLOR_U8				SpecularColor ;						// XyL[F
	FLOAT4					UVs[ 2 ] ;							// eNX`W
} ;

// Direct3D11p ff[^Ǘp\
struct MV1_MODEL_MANAGE_DIRECT3D11
{
	void *					CommonBuffer ;						// ɃVFCvW̍XVŎgpėpobt@
	int						CommonBufferSize ;					// ɃVFCvW̍XVŎgpėpobt@̃TCY
} ;

// Direct3D11p_obt@
struct MV1_VERTEXBUFFER_DIRECT3D11
{
	D_ID3D11Buffer *		VertexBuffer ;						// _obt@
	D_ID3D11Buffer *		IndexBuffer ;						// CfbNXobt@
} ;

// Direct3D11pgCAOXgf[^
struct MV1_TRIANGLE_LIST_BASE_DIRECT3D11
{
	BYTE					SkinFreeBoneVertexBufferUpdate ;	// X{[ȏ̃XLjObVp_f[^XVǂ( TRUE:XVς  FALSE:XV )
	void *					SkinFreeBoneVertexBuffer ;			// X{[ȏ̃XLjObVp_f[^
} ;

// Direct3D11pgCAOXg
struct MV1_TRIANGLE_LIST_DIRECT3D11
{
	void *					SkinFreeBoneVertexPositionBuffer ;	// X{[ȏ̃XLjObVp_Wf[^
	D_ID3D11Buffer *		VertexBuffer ;						// _obt@
} ;

// ϐ錾 --------------------------------------------------------------

extern MV1_MODEL_MANAGE_DIRECT3D11 MV1Man_D3D11 ;

// ֐vg^Cv錾-----------------------------------------------------------

// ėpobt@֐
extern	int				MV1_D3D11_CommonBuffer_Setup( int Size ) ;						// wTCY̔ėpobt@̏s
extern	int				MV1_D3D11_CommonBuffer_Terminate( void ) ;						// ėpobt@̌ns

// ˑ֐
extern	int				MV1_D3D11_Terminate_PF( void ) ;																// f@\̌n
extern	int				MV1_D3D11_TerminateModelBaseHandle_PF( MV1_MODEL_BASE *ModelBase ) ;							// ff[^nȟn
extern	int				MV1_D3D11_TerminateTriangleListBaseTempBuffer_PF( MV1_TRIANGLE_LIST_BASE *MBTList ) ;				// gCAOXg̈ꎞp̃obt@J
extern	void			MV1_D3D11_SetupPackDrawInfo_PF( MV1_MODEL_BASE *ModelBase ) ;									// `֌W̏ZbgAbv
extern	int				MV1_D3D11_SetupVertexBufferBase_PF( int MV1ModelBaseHandle, int DuplicateNum = 1, int ASyncThread = FALSE ) ;	// ff[^̒_obt@̃ZbgAbv( -1:G[ )
extern	int				MV1_D3D11_SetupVertexBuffer_PF( int MHandle, int ASyncThread = FALSE ) ;						// ff[^̒_obt@̃ZbgAbv( -1:G[ )
extern	int				MV1_D3D11_TerminateVertexBufferBase_PF( int MV1ModelBaseHandle ) ;								// _obt@̌n( -1:G[ )
extern	int				MV1_D3D11_TerminateVertexBuffer_PF( int MV1ModelHandle ) ;										// _obt@̌n( -1:G[ )
extern	int				MV1_D3D11_SetupShapeVertex_PF( int MHandle ) ;													// VFCvf[^̃ZbgAbv
extern	int				MV1_D3D11_BeginRender_PF( MV1_MODEL *Model ) ;													// Rcf̃_Ȍs
extern	int				MV1_D3D11_EndRender_PF( void ) ;																// Rcf̃_Ǒns
extern	void			MV1_D3D11_DrawMesh_PF( MV1_MESH *Mesh, int TriangleListIndex = -1 ) ;							// bV`敔𔲂o

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_MODEL

#endif // DX_NON_DIRECT3D11

#endif // DX_NON_GRAPHICS

#endif // __DXMODELD3D11_H__
