// -------------------------------------------------------------------------------
// 
// 		cwCu		nhǗvOwb_t@C
// 
// 				Ver 3.16b
// 
// -------------------------------------------------------------------------------

#ifndef __DXHANDLE_H__
#define __DXHANDLE_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxThread.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// nh̓
#define DX_HANDLEINDEX_MASK							(0x0000ffff)		// nhzCfbNX}XN
#define DX_HANDLEINDEX_MAX							(65536)				// nhzCfbNX̍ő吔

#define DX_HANDLECHECK_MASK							(0x03ff0000)		// nh̐`FbNp}XN
#define DX_HANDLECHECK_ADDRESS						(16)				// nh̐`FbNp}XN̊JnAhX
#define DX_HANDLECHECK_MAX							(1024)				// nh̐`FbNl̍ő吔

#define DX_HANDLETYPE_MASK							(0x7c000000)		// nh^Cv}XN
#define DX_HANDLETYPE_ADDRESS						(26)				// nh^Cv}XN̊JnAhX
#define DX_HANDLETYPE_MAX							(32)				// nh^Cv̍ő吔

#define DX_HANDLEERROR_MASK							(0x80000000)		// G[`FbN}XN( Oł͂ȂG[ )

// nh^Cv`
#define DX_HANDLETYPE_NONE							(0)					// nh^CvO͖gp
#define DX_HANDLETYPE_GRAPH							(1)					// OtBbNnh
#define DX_HANDLETYPE_SOFTIMAGE						(2)					// \tgEGAňC[Wnh
#define DX_HANDLETYPE_SOUND							(3)					// TEhnh
#define DX_HANDLETYPE_SOFTSOUND						(4)					// \tgTEhnh
#define DX_HANDLETYPE_MUSIC							(5)					// ~[WbNnh
#define DX_HANDLETYPE_MOVIE							(6)					// [r[nh
#define DX_HANDLETYPE_GMASK							(7)					// }XNnh
#define DX_HANDLETYPE_FONT							(8)					// tHgnh
#define DX_HANDLETYPE_KEYINPUT						(9)					// ̓nh
#define DX_HANDLETYPE_NETWORK						(10)				// lbg[Nnh
#define DX_HANDLETYPE_LIGHT							(11)				// Cg
#define DX_HANDLETYPE_SHADER						(12)				// VF[_[nh
#define DX_HANDLETYPE_MODEL_BASE					(13)				// Rcf{f[^
#define DX_HANDLETYPE_MODEL							(14)				// Rcf
#define DX_HANDLETYPE_VERTEX_BUFFER					(15)				// _obt@nh
#define DX_HANDLETYPE_INDEX_BUFFER					(16)				// CfbNXobt@nh
#define DX_HANDLETYPE_FILE							(17)				// t@Cnh
#define DX_HANDLETYPE_SHADOWMAP						(18)				// VhE}bvnh
#define DX_HANDLETYPE_SHADER_CONSTANT_BUFFER		(19)				// VF[_[p萔obt@nh

#define DX_HANDLETYPE_MASK_GRAPH					(DX_HANDLETYPE_GRAPH         << DX_HANDLETYPE_ADDRESS)		// OtBbNnh
#define DX_HANDLETYPE_MASK_SOFTIMAGE				(DX_HANDLETYPE_SOFTIMAGE     << DX_HANDLETYPE_ADDRESS)		// \tgEGAňC[Wnh
#define DX_HANDLETYPE_MASK_SOUND					(DX_HANDLETYPE_SOUND         << DX_HANDLETYPE_ADDRESS)		// TEhnh
#define DX_HANDLETYPE_MASK_SOFTSOUND				(DX_HANDLETYPE_SOFTSOUND     << DX_HANDLETYPE_ADDRESS)		// \tgTEhnh
#define DX_HANDLETYPE_MASK_MUSIC					(DX_HANDLETYPE_MUSIC         << DX_HANDLETYPE_ADDRESS)		// ~[WbNnh
#define DX_HANDLETYPE_MASK_MOVIE					(DX_HANDLETYPE_MOVIE         << DX_HANDLETYPE_ADDRESS)		// [r[nh
#define DX_HANDLETYPE_MASK_GMASK					(DX_HANDLETYPE_GMASK         << DX_HANDLETYPE_ADDRESS)		// }XNnh
#define DX_HANDLETYPE_MASK_FONT						(DX_HANDLETYPE_FONT          << DX_HANDLETYPE_ADDRESS)		// tHgnh
#define DX_HANDLETYPE_MASK_KEYINPUT					(DX_HANDLETYPE_KEYINPUT      << DX_HANDLETYPE_ADDRESS)		// ̓nh
#define DX_HANDLETYPE_MASK_NETWORK					(DX_HANDLETYPE_NETWORK       << DX_HANDLETYPE_ADDRESS)		// lbg[Nnh
#define DX_HANDLETYPE_MASK_LIGHT					(DX_HANDLETYPE_LIGHT         << DX_HANDLETYPE_ADDRESS)		// Cg
#define DX_HANDLETYPE_MASK_SHADER					(DX_HANDLETYPE_SHADER        << DX_HANDLETYPE_ADDRESS)		// VF[_[nh
#define DX_HANDLETYPE_MASK_MODEL_BASE				(DX_HANDLETYPE_MODEL_BASE    << DX_HANDLETYPE_ADDRESS)		// Rcf{f[^
#define DX_HANDLETYPE_MASK_MODEL					(DX_HANDLETYPE_MODEL         << DX_HANDLETYPE_ADDRESS)		// Rcf
#define DX_HANDLETYPE_MASK_VERTEX_BUFFER			(DX_HANDLETYPE_VERTEX_BUFFER << DX_HANDLETYPE_ADDRESS)		// _obt@nh
#define DX_HANDLETYPE_MASK_INDEX_BUFFER				(DX_HANDLETYPE_INDEX_BUFFER  << DX_HANDLETYPE_ADDRESS)		// CfbNXobt@nh
#define DX_HANDLETYPE_MASK_FILE						(DX_HANDLETYPE_FILE          << DX_HANDLETYPE_ADDRESS)		// t@Cnh
#define DX_HANDLETYPE_MASK_SHADOWMAP				(DX_HANDLETYPE_SHADOWMAP     << DX_HANDLETYPE_ADDRESS)		// VhE}bvnh

// nh̗L`FbN

#define HANDLECHKFULL_ASYNC( TYPE, HANDLE, INFO )																\
	  ( ( HandleManageArray[ (TYPE) ].InitializeFlag == FALSE ) ||												\
		( ( (HANDLE) & DX_HANDLEERROR_MASK ) != 0 ) ||															\
		( ( (HANDLE) & DX_HANDLETYPE_MASK  ) != HandleManageArray[ (TYPE) ].HandleTypeMask ) ||					\
		( ( (HANDLE) & DX_HANDLEINDEX_MASK ) >= HandleManageArray[ (TYPE) ].MaxNum ) ||							\
		( ( INFO = HandleManageArray[ (TYPE) ].Handle[ (HANDLE) & DX_HANDLEINDEX_MASK ] ) == NULL ) ||			\
		( (int)( (INFO)->ID << DX_HANDLECHECK_ADDRESS ) != ( (HANDLE) & DX_HANDLECHECK_MASK ) ) )

#ifndef DX_NON_ASYNCLOAD

	#define HANDLECHKFULL( TYPE, HANDLE, INFO )																			\
		  ( ( HandleManageArray[ (TYPE) ].InitializeFlag == FALSE ) ||												\
			( ( (HANDLE) & DX_HANDLEERROR_MASK ) != 0 ) ||															\
			( ( (HANDLE) & DX_HANDLETYPE_MASK ) != HandleManageArray[ (TYPE) ].HandleTypeMask ) ||					\
			( ( (HANDLE) & DX_HANDLEINDEX_MASK ) >= HandleManageArray[ (TYPE) ].MaxNum ) ||							\
			( ( INFO = HandleManageArray[ (TYPE) ].Handle[ (HANDLE) & DX_HANDLEINDEX_MASK ] ) == NULL ) ||			\
			( (int)( (INFO)->ID << DX_HANDLECHECK_ADDRESS ) != ( (HANDLE) & DX_HANDLECHECK_MASK ) ) ||				\
			( (INFO)->ASyncLoadCount != 0 ) )

#else // DX_NON_ASYNCLOAD

	#define HANDLECHKFULL( MANAGE, HANDLE, INFO )		HANDLECHKFULL_ASYNC( MANAGE, HANDLE, INFO )

#endif // DX_NON_ASYNCLOAD


#ifdef DX_NON_HANDLE_ERROR_CHECK

	#define HANDLECHK_ASYNC( TYPE, HANDLE, INFO )																	\
		  ( ( ( INFO = HandleManageArray[ (TYPE) ].Handle[ (HANDLE) & DX_HANDLEINDEX_MASK ] ) == NULL ) )

	#ifndef DX_NON_ASYNCLOAD

		#define HANDLECHK( TYPE, HANDLE, INFO )																			\
			  ( ( ( INFO = HandleManageArray[ (TYPE) ].Handle[ (HANDLE) & DX_HANDLEINDEX_MASK ] ) == NULL ) ||			\
				( (INFO)->ASyncLoadCount != 0 ) )

	#else // DX_NON_ASYNCLOAD

		#define HANDLECHK( MANAGE, HANDLE, INFO )		HANDLECHK_ASYNC( MANAGE, HANDLE, INFO )

	#endif // DX_NON_ASYNCLOAD


#else // DX_NON_HANDLE_ERROR_CHECK

	#define HANDLECHK_ASYNC( TYPE, HANDLE, INFO )	HANDLECHKFULL_ASYNC( TYPE, HANDLE, INFO )
	#define HANDLECHK( TYPE, HANDLE, INFO )			HANDLECHKFULL( TYPE, HANDLE, INFO )

#endif // DX_NON_HANDLE_ERROR_CHECK

// \̒` --------------------------------------------------------------------

// nhXg\
struct HANDLELIST
{
	int						Handle ;							// nh
	void					*Data ;								// f[^ւ̃|C^
	struct HANDLELIST		*Prev, *Next ;						// Xg̈OƎ̗vfւ̃|C^
} ;

// nh̋ʃf[^
struct HANDLEINFO
{
	int						ID ;								// G[`FbNphc
	int						Handle ;							// g̃nhl
	int						AllocSize ;							// ̊mۃTCY
	int						*DeleteFlag ;						// nh폜Ɂ|Pɂϐւ̃|C^
#ifndef DX_NON_ASYNCLOAD
	int						ASyncLoadCount ;					// 񓯊ǂݍݏ̑ΏۂƂȂĂ鐔
	int						ASyncLoadResult ;					// 񓯊ǂݍݏ̌
	int						ASyncDataNumber ;					// 񓯊ǂݍݏԍ
	volatile int			ASyncLoadFinishDeleteRequestFlag ;	// 񓯊ǂݍ݂nh폜tO
#endif
	HANDLELIST				List ;								// nhXg̈OƎ̗vfւ̃|C^
} ;

// nhǗ̋ʃf[^
struct HANDLEMANAGE
{
	int						InitializeFlag ;					// tO
	HANDLEINFO				**Handle ;							// nhւ̃|C^z
	HANDLELIST				ListFirst ;							// nhXg̐擪
	HANDLELIST				ListLast ;							// nhXg̖[
	int						HandleTypeMask ;					// nh^Cv}XN
	int						OneSize ;							// nhӂ̑傫
	int						MaxNum ;							// nh̍őTCY
	int						Num ;								// nh̐
	int						AreaMin ;							// nhzGAŏl
	int						AreaMax ;							// nhzGAől
	int						NextID ;							// ̃nhɊ蓖Ăhc
	DX_CRITICAL_SECTION		CriticalSection ;					// f[^ANZXpNeBJZNV
	int						( *InitializeFunction )( HANDLEINFO *HandleInfo ) ;	// nh̏֐ւ̃|C^
	int						( *TerminateFunction )( HANDLEINFO *HandleInfo ) ;	// nȟn֐ւ̃|C^
	const wchar_t			*Name ;								// nh
	char					NameUTF16LE[ 128 ] ;				// nh( UTF16LE )
} ;

// ϐ錾 --------------------------------------------------------------

extern HANDLEMANAGE HandleManageArray[ DX_HANDLETYPE_MAX ] ;

// ֐vg^Cv錾-----------------------------------------------------------

// nhʊ֌W
extern	int		InitializeHandleManage( int HandleType, int OneSize, int MaxNum, int ( *InitializeFunction )( HANDLEINFO *HandleInfo ), int ( *TerminateFunction )( HANDLEINFO *HandleInfo ), const wchar_t *Name ) ;	// nhǗ( InitializeFlag ɂ FALSE ĂKv )
extern	int		TerminateHandleManage( int HandleType ) ;																		// nhǗ̌ns

extern	int		AddHandle( int HandleType, int ASyncThread, int Handle /* = -1 */ ) ;										// nhǉ
extern	int		SubHandle( int Handle ) ;															// nh폜
extern	int		ReallocHandle( int Handle, size_t NewSize ) ;										// nh̏i[郁̈̃TCYύXA񓯊ǂݍݒłȂƂO
extern	HANDLEINFO *GetHandleInfo( int Handle ) ;													// nh̏擾
extern	int		AllHandleSub( int HandleType, int (*DeleteCancelCheckFunction)( HANDLEINFO *HandleInfo ) = NULL ) ;	// nhǗɓo^Ă邷ׂẴnh폜
#ifndef DX_NON_ASYNCLOAD
extern	int		IncASyncLoadCount( int Handle, int ASyncDataNumber ) ;								// nh̔񓯊ǂݍݒJEgCNg
extern	int		DecASyncLoadCount( int Handle ) ;													// nh̔񓯊ǂݍݒJEgfNg
extern	int		GetASyncLoadFinishDeleteFlag( int Handle ) ;										// nh̔񓯊ǂݍ݊ɍ폜邩ǂ̃tO擾
extern	int		WaitASyncLoad( int Handle ) ;														// nh񓯊ǂݍݒꍇA񓯊ǂݍ݂܂ő҂
#endif // DX_NON_ASYNCLOAD


// nhXg
extern	int		InitializeHandleList( HANDLELIST *First, HANDLELIST *Last ) ;					// Xg̏
extern	int		AddHandleList( HANDLELIST *First, HANDLELIST *List, int Handle, void *Data ) ;	// Xg֗vfǉ
extern	int		SubHandleList( HANDLELIST *List ) ;												// XgvfO
extern	int		NewMemoryHandleList( HANDLELIST *List, void *Data ) ;							// Xg݂郁ύXꂽꍇɃXg̑OXV

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXHANDLE_H__
